function x = gaussp_wiersz(A,b),
% eliminacja Gaussa z wyborem elementu gwnego w wierszu
  n=max(size(A));  
  ind = 1:n;                     % wektor pamitajcy kolejno kolumn
  for i=1:n-1,
    [xx,p]=max(abs(A(i,i:n)));   % p - indeks max. elementu w i-tym wierszu (liczc od i)
    if xx==0, x=inf; break; end,
    p=p+i-1;                     % p - indeks max. elementu w i-tym wierszu (liczc od 1)
    if p~=i,
      xx=A(1:n,i); A(1:n,i)=A(1:n,p); A(1:n,p)=xx;   % zamiana biecej (i-tej) kolumny mac.A z kolumn p
      xxx=ind(i);  ind(i)=ind(p);     ind(p)=xxx;    % zapamitanie zmiany w wektorze indeksw
    end,
    for j=i+1:n,                                    % ptla algorytmu Gaussa
      m=A(j,i)/A(i,i);
      A(j,i+1:n)=A(j,i+1:n)-m.*A(i,i+1:n);
      b(j)=b(j)-m*b(i);
    end,
  end,
  x=zeros(n,1);                                     % rozwizanie trjktnego ukadu rwna (eliminacja wstecz)
  x(n)=b(n)/A(n,n);
  for i=n-1:-1:1, x(i)=(b(i)-A(i,:)*x)/A(i,i); end,
  x(ind) = x;
