% Badanie wplywu skalowania wierszami na dokladnosc wyniku
clear all,
format long,  format compact,

% Tworzenie oryginalnego ukladu rownan:       A*x=b
n = 15;               % rozmiar ukladu rownan
A = rand(n);
% przyklady macierzy zle uwarunkowanych:
% A = hilb(n); % A = pascal(n); % A= vander(1:n);

x_acc = ones(n,1);    % rozwiazania dokladne
b = A*x_acc;          % wektor prawej strony ukladu rownan

% Skalowanie ukladu rownan:
D = eye(n);           % D - diagonalna macierz skalowania wierszami
for i = 1:n,
D(i,i) = 1/sum(abs(A(i,:)));  % obliczana suma modulow elementow wiersza
end
% Otrzymujemy rownowazny uklad rownan:     D*A*x = D*b

% Obliczanie wskaznikow uwarunkowania macierzy:
% cond(A) - The condition number of a matrix
% measures the sensitivity of the solution of a system of linear equations
% to errors in the data
wskazniki = [cond(A), cond(D*A)]

% 1. algorytm rozwiazywania ukladu rownan:
% mldivide (rownowazne uzyciu operatora \)
x1 = A\b;
x1_skal = (D*A)\(D*b);
disp('Bledy algorytmu mldivide');
[x_acc-x1, x_acc-x1_skal]

% 2. algorytm rozwiazywania ukladu rownan:
% X = linsolve(A,B) solves the linear system A*X = B
% using LU factorization with partial pivoting when A is square
% and QR factorization with column pivoting otherwise.
x2 = linsolve(A,b);
x2_skal = linsolve(D*A,D*b);
disp('Blad algorytmu linsolve');
[x_acc-x2,x_acc-x2_skal]
